/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Written by Denis Lukianov [denis@voxelsoft.com] July 2003 - Royalty Free, No Copyright
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef _COMMON_
#define _COMMON_

/////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define INSERT_CODEBYTES_BEFORE_OFFSETCALL				0x0000000D				// Dont mess with the first part of the insert or your EIP
																				// will be improperly offset, change only if you know what you're doing

/////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define INSERT_SPECIALCODE(n)							(0xBADF00D##n)			// 0xBADF00D* is extremely unlikely to occur naturally in the insert code
																				// If it does, change this prefix to a unique one

#define INSERT_SPECIALCODE_INSERTVA						INSERT_SPECIALCODE(0)	// These tell main app where to change the insert's data
#define INSERT_SPECIALCODE_INSERTSIZE					INSERT_SPECIALCODE(1)
#define INSERT_SPECIALCODE_ORIGINALVA					INSERT_SPECIALCODE(2)
#define INSERT_SPECIALCODE_ORIGINALSIZE					INSERT_SPECIALCODE(3)
#define INSERT_SPECIALCODE_ORIGINALIMPORTSADDRESSVA		INSERT_SPECIALCODE(4)
#define INSERT_SPECIALCODE_ORIGINALIMPORTSADDRESSSIZE	INSERT_SPECIALCODE(5)
#define INSERT_SPECIALCODE_NEWIMPORTSADDRESS			INSERT_SPECIALCODE(6)
#define INSERT_SPECIALCODE_ORIGINALENTRYVA				INSERT_SPECIALCODE(7)
#define INSERT_SPECIALCODE_FUNCTIONVA_GETCOMMANDLINE	INSERT_SPECIALCODE(8)
#define INSERT_SPECIALCODE_FUNCTIONVA_VIRTUALPROTECT	INSERT_SPECIALCODE(9)
#define INSERT_SPECIALCODE_WEAKHASH						INSERT_SPECIALCODE(a)
#define INSERT_SPECIALCODE_SCRAMBLEHASH					INSERT_SPECIALCODE(b)

/////////////////////////////////////////////////////////////////////////////////////////////////////////////

// These functions must be distributed in the insert
char *Insert_CalcPasswordFromCommandLine(char *cCommandLine);
unsigned int Insert_CalcCommandLineHash(char *cCommandLine);
// And all these below are also the ones to modify when changing encryption or hashes
unsigned int Insert_CalcStringHashWeak(char *cString);
unsigned int Insert_Descramble(char *cData, unsigned int iDataLen, char *cPassword, unsigned int iRandomScrambleHash);
void Insert_CopyMem(char *cDest, char *cSrc, unsigned int iDataLen);

// These functions only needs to be in the application
unsigned int Insert_Scramble(char *cData, unsigned int iDataLen, char *cPassword);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////

#endif // _COMMON_

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
