/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Written by Denis Lukianov [denis@voxelsoft.com] July 2003 - Royalty Free, No Copyright
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "../Common.h"

/////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifdef _DEBUG
#pragma message("Warning: Insert should NOT be built in Debug mode ***")
#endif

/////////////////////////////////////////////////////////////////////////////////////////////////////////////

unsigned int InsertMain(unsigned int iInsertVA, unsigned int iInsertCodeSize,
			   unsigned int iOriginalCodeVA, unsigned int iOriginalCodeSize,
			   unsigned int iOriginalImportAddressTableVA, unsigned int iOriginalImportAddressTableSize,
			   unsigned int iNewImportsVA,
			   unsigned int iOriginalEntryVA,
			   unsigned int iGetCommandLineVA, unsigned int iVirtualProtectVA,
			   unsigned int iWeakHash, unsigned int iScrambleHash,
			   unsigned int CurrentInsertOffset);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////

unsigned int EntryPoint()
{
	// DO NOT MODIFY UNLESS YOU KNOW WHAT YOU ARE DOING

	// /*CHANGES*/ tags indicate where data from the app links in with local data
	// The main app overwrites this data with the correct data
	// See Common.h for the module's complete data interface list
	unsigned int iReturnValue = 0;

	__asm
	{
			call	GetOwnCodeOffset				// Returns address of start of this code in eax
		
		GetOwnCodeOffset:
			pop		eax
			sub		eax, INSERT_CODEBYTES_BEFORE_OFFSETCALL

			// Set up parameters for InsertMain
			push	eax
			push	INSERT_SPECIALCODE_SCRAMBLEHASH
			push	INSERT_SPECIALCODE_WEAKHASH
			push	INSERT_SPECIALCODE_FUNCTIONVA_VIRTUALPROTECT
			push	INSERT_SPECIALCODE_FUNCTIONVA_GETCOMMANDLINE
			push	INSERT_SPECIALCODE_ORIGINALENTRYVA
			push	INSERT_SPECIALCODE_NEWIMPORTSADDRESS
			push	INSERT_SPECIALCODE_ORIGINALIMPORTSADDRESSSIZE
			push	INSERT_SPECIALCODE_ORIGINALIMPORTSADDRESSVA
			push	INSERT_SPECIALCODE_ORIGINALSIZE
			push	INSERT_SPECIALCODE_ORIGINALVA
			push	INSERT_SPECIALCODE_INSERTSIZE
			push	INSERT_SPECIALCODE_INSERTVA

			// Call InsertMain, which will act on the parameters
			call	InsertMain

			// Store return value
			mov		iReturnValue, eax

			// Pop all those parameters
			pop		eax
			pop		eax
			pop		eax
			pop		eax
			pop		eax
			pop		eax
			pop		eax
			pop		eax
			pop		eax
			pop		eax
			pop		eax
			pop		eax
			pop		eax
	}

	// Return whatever InsertMain returned
	return iReturnValue;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////

unsigned int Insert_CalcStringHashWeak(char *cString)
{
	if(!cString)
		return 0;

	if(!*cString)
		return 0;

	unsigned int iRet = 0;

	while(*cString)
	{
		//iRet += *(cString++);
		//iRet = iRet << 1;
		iRet++;

		cString++;
	}

	return iRet;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////

unsigned int Insert_Descramble(char *cData, unsigned int iDataLen, char *cPassword, unsigned int iRandomScrambleHash)
{
	// Target is those who dont know what they're looking for! And they will _NEVER TRY_!
	// Not a real encryption function, but just enough to get script kiddies
	// and unpaid coders to give up ;-) security through obscurity in a real world
	if(!cData || !iDataLen)
		return 0;

	unsigned int iPasswordOffset = 0;

	// cPassword now points to the actual password
	while(iDataLen--)
	{
		/*cData[iDataLen] -= cPassword[iPasswordOffset];
		cData[iDataLen] += iDataLen;

		iPasswordOffset++;
		if(!cPassword[iPasswordOffset])
			iPasswordOffset = 0;*/
		cData[iDataLen] --;
	}

	return 1; // Success
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////

void Insert_CopyMem(char *cDest, char *cSrc, unsigned int iDataLen)
{
	while(iDataLen--)
		cDest[iDataLen] = cSrc[iDataLen];
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////

char *Insert_CalcPasswordFromCommandLine(char *cCommandLine)
{
	// Must have a string commandline
	if(!cCommandLine)
		return 0;
	
	if(!*cCommandLine)
		return 0;

	char *Counter = 0;
	
	// To end of string, search for spaces
	while(*cCommandLine)
	{
		if(*cCommandLine == ' ')
			Counter = cCommandLine + 1; // Store last space
		cCommandLine++;
	}

	// Return character after last space or 0 if no spaces
	return Counter;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define PAGE_READWRITE				0x04
#define PAGE_EXECUTE				0x10     
#define PAGE_EXECUTE_READ			0x20     
#define PAGE_EXECUTE_READWRITE		0x40     
#define PAGE_EXECUTE_WRITECOPY		0x80     

/////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define RELATIVE_VA(n)					(((int)n) - ((int)iInsertVA))
#define RELATIVE_VA_TO_POINTER(n)		(((int)n) + ((int)CurrentInsertOffset))
#define VA_TO_POINTER(n)				((int)RELATIVE_VA((int)RELATIVE_VA_TO_POINTER((int)n)))

#define INIT_FUNCTION_POINTER(VA, FunctionPointerName) \
	unsigned int VA_##FunctionPointerName = VA_TO_POINTER(iGetCommandLineVA); \
	__asm \
	{ \
		__asm mov eax, VA_##FunctionPointerName \
		__asm mov edx, [eax] \
		__asm mov FunctionPointerName, edx \
	}

#pragma warning (disable: 4312)		// warning C4312: 'type cast' : conversion from 'int' to 'char *' of greater size
									// ignore this warning, for us in Win32/ASM unsigned int is just like a char*

/////////////////////////////////////////////////////////////////////////////////////////////////////////////

unsigned int InsertMain(unsigned int iInsertVA, unsigned int iInsertCodeSize,
			   unsigned int iOriginalCodeVA, unsigned int iOriginalCodeSize,
			   unsigned int iOriginalImportAddressTableVA, unsigned int iOriginalImportAddressTableSize,
			   unsigned int iNewImportsVA,
			   unsigned int iOriginalEntryVA,
			   unsigned int iGetCommandLineVA, unsigned int iVirtualProtectVA,
			   unsigned int iWeakHash, unsigned int iScrambleHash,
			   unsigned int CurrentInsertOffset)
{
	char *(*cGetCommandLine)();
	int (*VirtualProtect)(void*, unsigned int,  unsigned int, unsigned int*);
	
	INIT_FUNCTION_POINTER(iGetCommandLineVA, cGetCommandLine);
	INIT_FUNCTION_POINTER(iVirtualProtectVA, VirtualProtect);

	char *cCommandLine = cGetCommandLine();
	char *cPassword = Insert_CalcPasswordFromCommandLine(cCommandLine);

	// No password
	if(!cPassword)
		return 0;
	
	unsigned int iUserEnteredHash = Insert_CalcStringHashWeak(cPassword);

	// Bad password
	if(iWeakHash && iUserEnteredHash != iWeakHash)
		return 0;

	char *StartOfOrginal = (char *)VA_TO_POINTER(iOriginalCodeVA);
	char *StartOfNewImports = (char *)VA_TO_POINTER(iNewImportsVA);
	char *StartOfOrginalImports = (char *)VA_TO_POINTER(iOriginalImportAddressTableVA);

	if(iScrambleHash)
	{
		// Have to descramble the original code first

		//unsigned int iOldSectionPermissions;
		//if(!VirtualProtect(StartOfOrginal, iOriginalCodeSize, PAGE_EXECUTE_READWRITE, &iOldSectionPermissions))
		//	return 0;
		
		if(!Insert_Descramble(StartOfOrginal, iOriginalCodeSize, cPassword, iScrambleHash))
			return 0;
	}

	if(iNewImportsVA != iOriginalImportAddressTableVA)
	{
		// Have to fix old imports address table
		//unsigned int iOldSectionPermissions;
		//if(!VirtualProtect(StartOfOrginalImports, iOriginalImportAddressTableSize, PAGE_EXECUTE_WRITECOPY, &iOldSectionPermissions))
		//	return 0;

		Insert_CopyMem(StartOfOrginalImports, StartOfNewImports, iOriginalImportAddressTableSize);
	}

	// Call original code
	char *OriginalEntry = (char *)VA_TO_POINTER(iOriginalEntryVA);
	unsigned int iReturnValue;

	__asm
	{
		mov eax, OriginalEntry
		mov ebx, 0
		//mov [ebx], 0
		call eax
		mov iReturnValue, eax
	}
	
	// Return whatever original code returned
	return iReturnValue;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
